##    --------------------------------------------------------------------------------
##    $Id: Struct.pm,v 1.4 2002/12/19 01:06:27 joko Exp $
##    --------------------------------------------------------------------------------
##    $Log: Struct.pm,v $
##    Revision 1.4  2002/12/19 01:06:27  joko
##    + fixed isEmpty with ARRAYs
##
##    Revision 1.3  2002/12/13 21:47:04  joko
##    + fixes to 'sub isEmpty'
##
##    Revision 1.2  2002/12/05 07:56:34  joko
##    + updated/enhanced isEmpty (hacky?)
##
##    Revision 1.1  2002/11/29 04:49:30  joko
##    + initial check-in
##
##    --------------------------------------------------------------------------------


package Data::Compare::Struct;

use strict;
use warnings;

require Exporter;
our @ISA = qw( Exporter );
our @EXPORT_OK = qw( 
  &getRelations 
  &getDifference 
  &isEmpty
);

use Data::Dumper;

sub getRelations {
  my $a_ref = shift;
  my $b_ref = shift;
  my @a = @{$a_ref};
  my @b = @{$b_ref};

  my @isect = my @diff = my @union = ();
  my $e;
  my %count;
  
  foreach $e (@a, @b) { $count{$e}++ }

  foreach $e (keys %count) {
      push(@union, $e);
      push @{ $count{$e} == 2 ? \@isect : \@diff }, $e;
  }

  # bugfix: a diff is no diff if we don't even have an isect
  @diff = undef if !@isect;
  
  my $result = {
    union => \@union,
    isect => \@isect,
    diff => \@diff,
  };
  
  return $result;

}

sub getDifference {
  my $res = getRelations(shift, shift);
  return $res->{diff};
}

sub isEmpty {

  my $var = shift;
  my $ref = ref($var);
  my $reftype = '';
  $reftype = attributes::reftype($var) if $ref;

  #print "isEmpty is parsing variable ( ref $ref reftype $reftype )", "\n";
  
#print Dumper($var);
  
  my $found;

  if ($ref eq 'Set::Object') {
    $found = 1;
#print "members:", "\n";
#print Dumper($var->members());
#print "\n";
    my $tc = { ok => 0, count => 0, empty => 0 };
    foreach ($var->members()) {
#print "member!!", "\n";
      #print "empty: ", isEmpty($_), "\n";
      #$tc->{ok} = 1;
      $tc->{count}++;
      $tc->{empty}++ if isEmpty($_);
      #return $result if $result;
    }

#print Dumper($tc);
    
    return 1 if ($tc->{count} == $tc->{empty});
    return 0;
    
  }

  if ($reftype eq 'ARRAY') {
    my @arr = @$var;
    my $isReallyEmpty = ($#arr == -1 ? 1 : 0);
    return 1 if $isReallyEmpty;
    $found = 1;
    foreach (@arr) {
      #return 0 if defined $_;
      #return 1 if isEmpty($_);
      return 0 if !isEmpty($_);
    }

  } elsif ($reftype eq 'HASH') {
    my $empty = 1;
    $found = 1;
    foreach (keys %$var) {
# TODO: review and fix this!
=pod
      # recursion
      if (ref $var->{$_} eq 'Set::Object') {
        print "==========set", "\n";
        if (isEmpty($var->{$_})) {
          return 0;
          #next;
        }
      }
=cut
      next if ref $var->{$_} eq 'Set::Object';
      #return 0 if defined $var->{$_};
      #return 1 if isEmpty($var->{$_});
      my $elem_empty = isEmpty($var->{$_});
      
#print "elem: $elem_empty\n";
      $empty &&= $elem_empty;
    }
    return $empty;
    #return 0;
  
  } else {
    $found = 1;
    return 0 if defined $var;
  }
  
  if (!$found) {
    print "isEmpty could not parse variable ( ref $ref reftype $reftype )", "\n";
  }

  #print "EMPTY!!!", "\n";

  return 1;
  
}

1;
