##    ------------------------------------------------------------------------
##
##    $Id: Sync.pm,v 1.15 2003/01/20 16:58:07 joko Exp $
##
##    Copyright (c) 2002  Andreas Motl <andreas.motl@ilo.de>
##
##    See COPYRIGHT section in pod text below for usage and distribution rights.
##
##    ------------------------------------------------------------------------
##    $Log: Sync.pm,v $
##    Revision 1.15  2003/01/20 16:58:07  joko
##    + loading new plugin-modules on startup: 'Metadata' and 'StorageInterface' - both refactored from other - already established - plugin-modules
##
##    Revision 1.14  2003/01/19 03:25:54  joko
##    + modified header
##
##    Revision 1.13  2003/01/19 01:23:03  joko
##    + new from Data/Transfer/Sync.pm
##    ------------------------------------------------------------------------


package Data::Transfer::Sync;

use strict;
use warnings;

use base qw( DesignPattern::Object );
use base qw( DesignPattern::Bridge );


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -   main

# get logger instance
my $logger = Log::Dispatch::Config->instance;

sub _init {
  my $self = shift;
  $logger->debug( __PACKAGE__ . "->new" );
  $self->load('Core');
  $self->load('Metadata');
  $self->load('API');
  $self->load('StorageInterface');
  $self->configure(@_);
}

1;
