## ---------------------------------------------------------------------------
##  $Id: String.pm,v 1.1 2003/01/19 03:27:36 joko Exp $
## ---------------------------------------------------------------------------
##  $Log: String.pm,v $
##  Revision 1.1  2003/01/19 03:27:36  joko
##  + initial check-in
##
## ---------------------------------------------------------------------------


package Data::Transform::String;

use strict;
use warnings;

require Exporter;
our @ISA = qw( Exporter );
our @EXPORT_OK = qw( 
  stripHtml stripSpaces stripNewLines toReal trim
);

sub stripHtml {
  my $html = shift;
  my $result = '';
  #$html =~ s/<br>(.*)/ - ($1)/i;
  my $p = HTML::PullParser->new(
    doc => \$html,
    text => 'text',
    unbroken_text => 1,
  );
  while (my $token = $p->get_token()) {
    my $text = join('', @{$token});
    $result .= $text;
  }
  #$result =~ s/&nbsp;//g;
  return $result;
}

sub stripSpaces {
  my $text = shift;
  #print "text: $text", "\n";
  #print "ord: ", ord(substr($text, 0, 1)), "\n";
  $text =~ s/^\s*//g;
  $text =~ s/\s*$//g;
  return $text;
}

sub trim {
  my $string = shift;
  return stripSpaces($string);
}

sub stripNewLines {
  my $text = shift;
  #print "text: $text", "\n";
  #print "ord: ", ord(substr($text, 0, 1)), "\n";
  $text =~ s/\n//g;
  #$text =~ s/\s*$//g;
  return $text;
}

sub toReal {
  my $string = shift;
  $string =~ m/(\d+\.*\d+)/;
  my $real = $1;
  return $real;
}

1;
