package OEF::Component::Task;

use strict;
use warnings;

use base qw( 
  DesignPattern::Object
  DesignPattern::Object::Logger
);

use Class::Tom qw ( restore );
use Data::Dumper;

use BizWorks::Boot qw( $bizWorks $bizProcess );
use libp qw( now );
use Data::Transform::Deep qw( hash2object object2hash );


sub _init {
  my $self = shift;
  $self->log("INIT");

  # just boot database called "oefcore"
  # TODO: REVIEW: just boot if not booted yet.....
  #$self->{boot} = BizWorks::Boot->new( use_databases => [qw( oefcore )] );

  if ($self->{guid}) {
    my $task = $bizWorks->{oefcore}->getObjectByGuid($self->{guid}, { classname => 'Task' });
    $self->{_context_raw} = $task->{context};
    
  } else {
  
    # create fresh task-object, if no "guid" is given
    $self->{TASK} = Task->new(
      stamp => now(),
      #context => ,
    );
    $bizWorks->{oefcore}->insert($self->{TASK});
    $self->{guid} = $self->{TASK}->{guid};

  }  
  
  
}


sub _check {
  my $self = shift;
  if (!$self->getGuid()) {
    return 1;
  }
}

sub start {
  my $self = shift;
  
  return if ($self->skip("task has no guid", $self->_check()));

#print Dumper($self);
#exit;
  
  $self->log("task " . $self->getGuid() . " starting.");
  $self->{TASK}->{begin} = now();
  $self->run() if $self->can('run');
  #$self->_run();
  $self->{TASK}->{end} = now();
  $self->log("task " . $self->getGuid() . " finished.");
}

sub suspend {
  my $self = shift;
  $self->log("task " . $self->getGuid() . " suspending.");
    $self->log("SUSPEND");
    my $tom = Class::Tom->new();
=pod
print Dumper($self);
    if ($self->isa('Tie::SecureHash')) {
      print "YEP!", "\n";
    }
=cut
    $tom->insert($self);
    $self->{TASK}->{context} = $tom->store();
    $bizWorks->{oefcore}->update($self->{TASK});
  $self->log("task " . $self->getGuid() . " suspended.");
}

sub resume {
  my $self = shift;
  $self->log("task " . $self->getGuid() . " resuming.");
    
#print $self->{_context_raw}, "\n";
    
    # restore flattened structure
    my $tom = restore( $self->{_context_raw} );
    
    # register passivated methods
    $tom->register();

    # extract object
    my $obj = $tom->extract();
    
    #print "ref: ", ref $obj, "\n";
    my $classname = ref $obj;
    
    # dynamically (eval!) mix object-methods into current instance
    eval("package $classname; use mixin::with 'OEF::Component::Task';");
    print $@, "\n" if $@;

    eval("use mixin '$classname';");
    print $@, "\n" if $@;

#print "class: $classname", "\n";

    # mix former instance-variables into current/active instance
    # TODO: refactor/rework this!
    hash2object($self, $obj, { init => 1, pattern_strip_key => '^.*::' } );

print Dumper($self);
    
  $self->log("task " . $self->getGuid() . " resumed.");
}

sub getGuid {
  my $self = shift;
  return $self->{guid};
}

1;
